import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourProjectGroupPurchaseRebate from '@/types/table/tourProjectGroupPurchaseRebate';
import { TourUserData } from '@/api/generated/tourUserController';
import { TourProjectGroupPurchaseData } from '@/api/generated/tourProjectGroupPurchaseController';
import { TourOrderData } from '@/api/generated/tourOrderController';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourProjectGroupPurchaseRebateData extends TourProjectGroupPurchaseRebate {
  tourUser?: TourUserData;
  tourProjectGroupPurchase?: TourProjectGroupPurchaseData;
  tourOrder?: TourOrderData;
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourProjectGroupPurchaseRebateController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourProjectGroupPurchaseRebateData>>(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourProjectGroupPurchaseRebateData>(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseRebate/deleteBatch', params, httpOptions);
  }
}
